/************************************************************************
	HardwareProfile.h
************************************************************************/

#ifndef _HARDWAREPROFILE_H
#define _HARDWAREPROFILE_H

// Oscillator frequency (48MHz)
#define CLOCK_FREQ 48000000

// Common useful definitions
#define INPUT_PIN 1
#define OUTPUT_PIN 0

//*******************************************************************************/
// (This section is the set of definitions required by the MCHPFSUSB framework.)
//*******************************************************************************/

// Device Vendor Indentifier
#define USB_VID	0x04D8
// Device Product Indentifier
#define USB_PID	0x0042

// Manufacturer string descriptor
#define MSDLENGTH	12
#define MSD		'S','I','L','I','C','O','N',' ','C','H','I','P'

// Product String descriptor
#define PSDLENGTH	20
#define PSD		'S','o','u','n','d',' ','E','f','f','e','c','t','s',' ','M','o','d','u','l','e'

// Device serial number string descriptor
#define DSNLENGTH	7
#define DSN		'S','F','X','_','0','.','1'

#endif
